<!DOCTYPE html>
<html>
<head>
<link rel="stylesheet" href="github-markdown.css">
</head>
<body>
<p><strong>An Interactive PowerShell Tutorial</strong> (inspired by and somewhat aligned with <a href="https://docs.microsoft.com/en-us/powershell/scripting/learn/ps101/00-introduction">PowerShell 101</a>)</p>
<p>[[<em>TOC</em>]]</p>
<h1 id="powershell-1-standalone-host">PowerShell 1: Standalone Host</h1>
<p>This first part of the tutorial assumes you are working on a standalone Windows Server 2019 (you can probably also do this in a Windows 10).</p>
<h2 id="windows-introduction-and-background">Windows Introduction and Background</h2>
<p>Windows have GUI (the <a href="https://en.wikipedia.org/wiki/Windows_shell">Windows Shell</a>), the old command line interface cmd and the preferred command line interface PowerShell (cmd and PowerShell can also both be used in <a href="https://github.com/microsoft/terminal">Windows Terminal</a>).</p>
<p>To copy and paste on the command line: * copy: mark the text and hit Enter * paste: right click</p>
<p>If you are using a Windows with a different keyboard layout than what you are used to (e.g. if you have downloaded from <a href="https://developer.microsoft.com/en-us/windows/downloads/virtual-machines">Get a Windows 10 development environment</a>)</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb1-1"><a href="#cb1-1"></a>Get-WinUserLanguageList</span>
<span id="cb1-2"><a href="#cb1-2"></a>Set-WinUserLanguageList -LanguageList nb-NO</span></code></pre></div>
<h2 id="getting-started-with-powershell">Getting Started with PowerShell</h2>
<p>By default, Windows has the old Windows PowerShell (PowerShell 5.1) installed. We want the new cross-platform version of PowerShell called PowerShell Core. Note that the Windows PowerShell executable file is called <code>powershell.exe</code> while the PowerShell core executable file is called <code>pwsh.exe</code> (you can also installed PowerShell core on Linux and Mac and start it with the command <code>pwsh</code>).</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb2-1"><a href="#cb2-1"></a><span class="co"># search powershell, right click, Run as administrator</span></span>
<span id="cb2-2"><a href="#cb2-2"></a></span>
<span id="cb2-3"><a href="#cb2-3"></a><span class="fu">Set-ExecutionPolicy</span> Bypass -Scope <span class="kw">Process</span> -Force</span>
<span id="cb2-4"><a href="#cb2-4"></a>[System.<span class="fu">Net</span>.<span class="fu">ServicePointManager</span>]::SecurityProtocol = [System.<span class="fu">Net</span>.<span class="fu">ServicePointManager</span>]::SecurityProtocol -bor 3072</span>
<span id="cb2-5"><a href="#cb2-5"></a><span class="fu">iex</span> ((<span class="fu">New-Object</span> System.<span class="fu">Net</span>.<span class="fu">WebClient</span>).<span class="fu">DownloadString</span>(&#39;https://chocolatey.<span class="fu">org</span>/install.<span class="fu">ps1</span>&#39;))</span>
<span id="cb2-6"><a href="#cb2-6"></a>choco install -y powershell-core</span>
<span id="cb2-7"><a href="#cb2-7"></a><span class="kw">exit</span></span></code></pre></div>
<p>PowerShell has <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_execution_policies">ExecutionPolicies</a> which are meant to help you protect you from yourself, e.g. unintentional execution of downloaded scripts. Sometimes we have to change the execution policy to be allowed to execute our scripts. Use <code>Get-ExecutionPolicy</code> to see which policy is set on the system, and use <code>Set-ExecutionPolicy</code> to change it. We set this to <code>RemoteSigned</code> to require scripts downloaded from the Internet to be digitally signed by a trusted publisher. The default for Windows clients is <code>Restricted</code>, for servers it is <code>RemoteSigned</code>. If we have downloaded a script that is not digitally signed by a trusted publisher, we can still execute it if we manually <code>Unblock-File</code>.</p>
<p>The Chocolatey package manager (for installing software on Windows) is very cool, but make sure you know which risk you are taking (think <a href="https://github.blog/2020-09-02-secure-your-software-supply-chain-and-protect-against-supply-chain-threats-github-blog/">supply chain security</a>). Read <a href="https://chocolatey.org/docs/security#rigorous-moderation-process-for-community-packages">Rigorous Moderation Process for Community Packages</a>. You can use Chocolatey to install most of the software you need (like we just did with PowerShell Core). You can check for outdated programs you have installed with Chocolatey and upgrade them with</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb3-1"><a href="#cb3-1"></a><span class="co"># search pwsh, right click, Run as administrator</span></span>
<span id="cb3-2"><a href="#cb3-2"></a><span class="co"># you might have to run Set-ExecutionPolicy RemoteSigned</span></span>
<span id="cb3-3"><a href="#cb3-3"></a>choco outdated</span>
<span id="cb3-4"><a href="#cb3-4"></a>choco upgrade all</span></code></pre></div>
<blockquote>
<p>Use <code>choco</code> to install the package <code>autoruns</code>. Launch <code>autoruns</code> after installation, what is the purpose of this software? What is <a href="https://docs.microsoft.com/en-us/sysinternals/">Sysinternals</a>?</p>
</blockquote>
<p><strong>Before we continue, make sure you are NOT USING PowerShell AS ADMINISTRATOR unless explicitely told so, we only use “run as administrator” when we need to do system administration tasks like installing software, adding users, stopping important services, etc</strong> (Remember: humans make mistakes, computers do not. When we humans make mistakes we save ourselves of so much trouble if we are a user with low privileges.)</p>
<h2 id="cmdlets-parameters-aliases-and-help">Cmdlets, Parameters, Aliases and Help</h2>
<p>PowerShell commands are called <em>cmdlets</em> (pronounced “commandlets”) and have the syntax <code>verb-noun</code>, e.g. <code>Write-Output</code>. Fortunately most of the cmdlets <a href="https://docs.microsoft.com/en-us/powershell/scripting/samples/appendix-1---compatibility-aliases">have aliases corresponding to the commands you might know from DOS (cmd.exe) or Unix/Linux</a>. In addition there is also a short PowerShell alias to most cmdlets. To find the cmdlet to a command you know from before you can use the cmdlet <code>Get-Alias</code>:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb4-1"><a href="#cb4-1"></a><span class="co"># is there a cmdlet corresponding to Unix/Linux ls?</span></span>
<span id="cb4-2"><a href="#cb4-2"></a><span class="fu">Get-Alias</span> <span class="fu">ls</span></span>
<span id="cb4-3"><a href="#cb4-3"></a><span class="co"># are there many aliases to Get-ChildItem?</span></span>
<span id="cb4-4"><a href="#cb4-4"></a><span class="fu">Get-Alias</span> -Definition <span class="fu">Get-ChildItem</span></span>
<span id="cb4-5"><a href="#cb4-5"></a><span class="co"># list all aliases</span></span>
<span id="cb4-6"><a href="#cb4-6"></a><span class="fu">Get-Alias</span></span>
<span id="cb4-7"><a href="#cb4-7"></a><span class="co"># or list them from the &quot;alias drive&quot; (similar to your C:\ drive)</span></span>
<span id="cb4-8"><a href="#cb4-8"></a><span class="fu">Get-ChildItem</span> Alias:\</span></code></pre></div>
<p>Note: Aliases are nice, but get used to using the full cmdlet names, especially in your scripts. This makes your scripts more readable and easier for others to understand.</p>
<p>These cmdlets has several parameters/options that are specific to each one, but there are also a set of <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_commonparameters#long-description">common parameters</a>. Note particularly the options <code>-Verbose</code>, <code>-ErrorAction SilentlyContinue</code> and <code>-WhatIf</code>.</p>
<blockquote>
<p>Try <code>Get-Service | Stop-Service -WhatIf</code>. Try <code>Get-ChildItem -Recurse C:\Windows\System32\wbem\MO*</code> with and without the option <code>-ErrorAction SilentlyContinue</code>.</p>
</blockquote>
<p>Btw, a running program is called <a href="https://docs.microsoft.com/en-us/windows/win32/procthread/processes-and-threads">a <em>process</em> and a process most of the times have <em>threads</em></a>. <a href="https://docs.microsoft.com/en-us/windows/win32/services/services">A service is a special process</a> wrapped around another process with the purpose of controlling all service processes in the same way. Think of a service as something that is running on your computer without anyone being logged in (sometimes a process or a group of processes is <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_jobs">wrapped in a job</a> but this is not as common as a service).</p>
<p>To get help with the cmdlets, use the cmdlet <code>Get-Help</code>, e.g. <code>Get-Help Write-Output | more</code>. A nice feature is that you can view the help page in your browser (on the internet) by adding the parameter <code>-Online</code>, e.g. <code>Get-Help Write-Output -Online</code>. If you don’t want to go online, you can use <code>Get-Help Write-Output -Examples</code> or <code>Get-Help Write-Output -Full</code>.</p>
<p>Note that you can use TAB-completion on both commands and parameters.</p>
<blockquote>
<p>Use <code>Get-Help Select-String -online</code> (note: <code>Select-String</code> is similar to Linux <code>grep</code>) and find the example code for “Find a string in subdirectories”. Try it. Did you get an access error (red text)? If so, repeat the command with the option <code>-ErrorAction SilentlyContinue</code> added to <code>Get-ChildItem</code>. Searching file systems is slow, how slow? Repeat the command but put braces (<code>{ }</code>) around it and prepend it with the cmdlet <code>Measure-Command</code>.</p>
</blockquote>
<p>To find which cmdlets you can use, you have the cmdlet <code>Get-Command</code></p>
<blockquote>
<p>Try <code>Get-Command *DNS*</code></p>
</blockquote>
<p>(and if you want to have some fun, repeat <code>Get-Command | Get-Random | Get-Help</code> a couple of times)</p>
<h2 id="drives-profiles-variables-and-namespaces">Drives, Profiles, Variables and Namespaces</h2>
<p>A PowerShell drive is a data store which you can access like a file system. This might seem a bit strange at first, but it is very practical and allows us to reuse the same set of commands for accessing different kinds of data.</p>
<blockquote>
<p><code>Get-PSDrive</code>, navigate (<code>cd</code>) to all drives you did not know about, and do <code>Get-ChildItem</code> and/or <code>Get-ChildItem -Recurse</code> to explore what is there. E.g. do <code>Get-ChildItem -Path Cert:\LocalMachine\CA</code> to see the Certificate Authorities on Local Machine.</p>
</blockquote>
<p>You can create variables in PowerShell which by default will be in the <code>variable</code> <em>namespace</em>. In other words, PowerShell has namespaces. Sometimes you have to specify namespace and sometimes you don’t:</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb5-1"><a href="#cb5-1"></a><span class="va">$a</span> = &#39;heisan&#39;</span>
<span id="cb5-2"><a href="#cb5-2"></a><span class="fu">Write-Output</span> <span class="va">$a</span></span>
<span id="cb5-3"><a href="#cb5-3"></a><span class="fu">Write-Output</span> <span class="va">$variable</span>:a</span>
<span id="cb5-4"><a href="#cb5-4"></a><span class="fu">cd</span> <span class="va">$env</span>:homepath</span>
<span id="cb5-5"><a href="#cb5-5"></a><span class="va">$env</span>:homepath</span>
<span id="cb5-6"><a href="#cb5-6"></a><span class="va">$homepath</span></span>
<span id="cb5-7"><a href="#cb5-7"></a><span class="va">$home</span></span>
<span id="cb5-8"><a href="#cb5-8"></a><span class="va">$env</span>:home</span>
<span id="cb5-9"><a href="#cb5-9"></a><span class="va">$profile</span></span>
<span id="cb5-10"><a href="#cb5-10"></a><span class="fu">Get-Content</span> <span class="va">$profile</span> <span class="co"># Get-Content is same as Linux cat</span></span></code></pre></div>
<p><a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_environment_variables">Environment variables</a> are in the namespace <code>env</code>. A <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_profiles">Profile</a> is basically a script that is executed when you start PowerShell and can be used to modify your environment.</p>
<h2 id="objects-and-get-member">Objects and Get-Member</h2>
<p>The “Power” in PowerShell comes from piping objects instead of just a bytestream. E.g. if you want to lookup the IP address of a fqdn (Fully Qualified Domain Name) you can use the old-style <code>nslookup</code> program or the new PowerShell cmdlet <code>Resolve-DnsName</code></p>
<div class="sourceCode" id="cb6"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb6-1"><a href="#cb6-1"></a>nslookup.<span class="fu">exe</span> ftp.<span class="fu">uninett</span>.<span class="fu">no</span></span>
<span id="cb6-2"><a href="#cb6-2"></a>nslookup.<span class="fu">exe</span> ftp.<span class="fu">uninett</span>.<span class="fu">no</span> | <span class="fu">Get-Member</span></span>
<span id="cb6-3"><a href="#cb6-3"></a><span class="co"># notice the top line &quot;TypeName: System.String&quot;, the command only outputs a string</span></span>
<span id="cb6-4"><a href="#cb6-4"></a></span>
<span id="cb6-5"><a href="#cb6-5"></a>Resolve-DnsName ftp.<span class="fu">uninett</span>.<span class="fu">no</span></span>
<span id="cb6-6"><a href="#cb6-6"></a>Resolve-DnsName ftp.<span class="fu">uninett</span>.<span class="fu">no</span> | <span class="fu">Get-Member</span></span>
<span id="cb6-7"><a href="#cb6-7"></a><span class="co"># again, notice the TypeNames, to get the IPv4 address we can now simply do</span></span>
<span id="cb6-8"><a href="#cb6-8"></a>(Resolve-DnsName ftp.<span class="fu">uninett</span>.<span class="fu">no</span>).<span class="fu">IP4Address</span></span>
<span id="cb6-9"><a href="#cb6-9"></a><span class="co"># very hard to do the same with nslookup, </span></span>
<span id="cb6-10"><a href="#cb6-10"></a><span class="co"># would need to do some Select-String RegExp magic, maybe with some head/tail</span></span></code></pre></div>
<p>When piping objects you can use <code>Get-Member</code> to see which properties and methods the object contains. To access a property or method of an object you can use the syntax <code>Object.Property</code> or <code>(Cmdlet-that-returns-object).Property</code> as shown above.</p>
<blockquote>
<p>Do <code>$name = 'mysil'</code>. Use the properties and methods of the <code>$name</code>-object to * find out how many characters the string contains * print the string in upper case</p>
</blockquote>
<h2 id="select-object">Select-Object</h2>
<p>You can create a new object in the pipeline with a reduced set of properties/methods with <code>Select-Object</code></p>
<div class="sourceCode" id="cb7"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb7-1"><a href="#cb7-1"></a><span class="co"># create a file</span></span>
<span id="cb7-2"><a href="#cb7-2"></a><span class="fu">Write-Output</span> mysil &gt; abc.<span class="fu">txt</span></span>
<span id="cb7-3"><a href="#cb7-3"></a><span class="co"># compare the output of</span></span>
<span id="cb7-4"><a href="#cb7-4"></a><span class="fu">Get-ChildItem</span> .\abc.<span class="fu">txt</span> | <span class="fu">Get-Member</span></span>
<span id="cb7-5"><a href="#cb7-5"></a><span class="co"># with</span></span>
<span id="cb7-6"><a href="#cb7-6"></a><span class="fu">Get-ChildItem</span> .\abc.<span class="fu">txt</span> | <span class="fu">Select-Object</span> -Property Name,LastWriteTime | <span class="fu">Get-Member</span></span></code></pre></div>
<p>And you can use <code>Select-Object</code> similar to head and tail in Unix/Linux (which is something you will probably do quite frequently)</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb8-1"><a href="#cb8-1"></a><span class="fu">Get-Process</span> | <span class="fu">Select-Object</span> -Last 5</span>
<span id="cb8-2"><a href="#cb8-2"></a><span class="fu">Get-ChildItem</span> | <span class="fu">Select-Object</span> -First 3</span></code></pre></div>
<blockquote>
<p>Do <code>Get-Content C:\Windows\System32\drivers\etc\services</code> and pipe this to <code>Select-Object</code> in such a way that you only output lines 30 to 50</p>
</blockquote>
<p>Advanced: sometimes we also use <code>Select-Object</code> to “create new properties on the fly”. E.g. if we want to show the owner of files this is not directly available as a property, but we can do a trick with a hash table (see also <a href="https://gitlab.com/erikhje/dcsg1005/-/blob/master/powershell.md#variable-array-and-hashtable">Appendix</a>):</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb9-1"><a href="#cb9-1"></a><span class="fu">Get-ChildItem</span> | </span>
<span id="cb9-2"><a href="#cb9-2"></a>  <span class="fu">Select-Object</span> Name,Directory,@{Name=<span class="st">&quot;Owner&quot;</span>;Expression={(<span class="fu">Get-ACL</span> <span class="va">$_</span>.<span class="fu">Fullname</span>).<span class="fu">Owner</span>}},CreationTime,LastAccessTime |</span>
<span id="cb9-3"><a href="#cb9-3"></a>    <span class="fu">Format-Table</span></span></code></pre></div>
<h2 id="where-object-where">Where-Object, Where, ?</h2>
<p>Objects in the pipeline can be addressed with the <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_automatic_variables">automatic variable</a> <code>$_</code> and <code>Where-Object</code> is used to filter objects similar to Unix/Linux <code>grep</code></p>
<div class="sourceCode" id="cb10"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb10-1"><a href="#cb10-1"></a><span class="fu">Get-Service</span></span>
<span id="cb10-2"><a href="#cb10-2"></a><span class="fu">Get-Service</span> | <span class="fu">Where-Object</span> {<span class="va">$_</span>.<span class="fu">Status</span> -eq &#39;Running&#39;}</span>
<span id="cb10-3"><a href="#cb10-3"></a><span class="co"># -eq is &#39;exactly equal&#39; while -match matches against a regular expression:</span></span>
<span id="cb10-4"><a href="#cb10-4"></a><span class="fu">Get-Service</span> | <span class="fu">Where-Object</span> {<span class="va">$_</span>.<span class="fu">Status</span> -eq &#39;Running&#39; -and <span class="va">$_</span>.<span class="fu">StartupType</span> -match &#39;.*auto.*&#39;}</span></code></pre></div>
<p>There is a plethora of comparison operaters you can use, browse the web page <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_comparison_operators">About Comparison Operators</a> to see the options you have.</p>
<blockquote>
<p>Use <code>Get-Process</code> and <code>Where-Object</code> to * list all processes with the property Name equals ‘pwsh’ * list all processes with the property WorkingSet greater than 10MB * use Get-Member to find a property that will show you the full path to the executable file pwsh.exe (for the powershell process object)</p>
</blockquote>
<p>Note: you should for efficiency reasons (and thereby climate change reasons) filter objects as far left as you can, e.g. do <code>Get-Process -Name notepad</code> instead of <code>Get-Process | Where-Object {$_.Name -eq 'notepad'}</code></p>
<h2 id="format--out-">Format-* Out-*</h2>
<p>These cmdlets should always be at the end of the pipeline since they are used to format/redirect the final output from the command pipeline. Remember this rule: <em>filter to the left, format to the right</em>.</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb11-1"><a href="#cb11-1"></a><span class="fu">Get-ChildItem</span> -File C:\Windows\ | <span class="fu">Format-List</span> -Property Name,Length,LastAccessTime</span>
<span id="cb11-2"><a href="#cb11-2"></a><span class="fu">Get-ChildItem</span> -File C:\Windows\ | <span class="fu">Format-Table</span> -Property Name,Length,LastAccessTime</span></code></pre></div>
<p>You can also send output from the pipeline to other places than the terminal window (you can redirect output to a file with <code>&gt;</code> just like in Linux).</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb12-1"><a href="#cb12-1"></a><span class="fu">Get-ChildItem</span> -File b* | <span class="fu">Out-File</span> b.<span class="fu">dat</span>          <span class="co"># is the same as &gt; b.dat</span></span>
<span id="cb12-2"><a href="#cb12-2"></a><span class="fu">Get-ChildItem</span> -File b* | <span class="fu">Out-GridView</span></span>
<span id="cb12-3"><a href="#cb12-3"></a><span class="fu">Get-ChildItem</span> -File b* | clip                    <span class="co"># send it to the clipboard</span></span>
<span id="cb12-4"><a href="#cb12-4"></a><span class="fu">Get-ChildItem</span> -File b* | <span class="fu">Export-Csv</span> <span class="va">$home</span>\a.<span class="fu">csv</span></span></code></pre></div>
<blockquote>
<p>TAB through all <code>ConvertTo-</code> cmdlets</p>
</blockquote>
<p>Note: sometimes when you try to output data, you can get strange results because of how PowerShell behaves which is not always intuitive, e.g. PowerShell automatically adds <code>Out-Default</code> to the end of every pipeline. See example when <a href="https://superuser.com/a/1564334">using semicolons</a> (same thing can happen inside scripts/functions).</p>
<h2 id="sort-object">Sort-Object</h2>
<p>You can use <code>Sort-Object</code> to sort on any property of an object, here are some nice examples including a very practical use of <code>Get-Date</code> (note: a command line can span several lines)</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb13-1"><a href="#cb13-1"></a><span class="fu">Get-ChildItem</span> C:\Windows\System32\ |</span>
<span id="cb13-2"><a href="#cb13-2"></a>  <span class="fu">Where-Object</span> {<span class="va">$_</span>.<span class="fu">LastAccessTime</span> -gt (<span class="fu">Get-Date</span>).<span class="fu">AddMinutes</span>(-30)} |</span>
<span id="cb13-3"><a href="#cb13-3"></a>    <span class="fu">Sort-Object</span> -Property Length -Descending</span>
<span id="cb13-4"><a href="#cb13-4"></a><span class="fu">Get-ChildItem</span> C:\Windows\System32\ |</span>
<span id="cb13-5"><a href="#cb13-5"></a>  <span class="fu">Where-Object</span> {<span class="va">$_</span>.<span class="fu">LastAccessTime</span> -gt (<span class="fu">Get-Date</span>).<span class="fu">AddMinutes</span>(-30)} |</span>
<span id="cb13-6"><a href="#cb13-6"></a>    <span class="fu">Sort-Object</span> -Property Length |</span>
<span id="cb13-7"><a href="#cb13-7"></a>      <span class="fu">Select-Object</span> -Last 10</span></code></pre></div>
<p>Notice the importance of time stamps. Time stamps are crucial in log files, in backups, in all kinds of forensics investigations (building a timeline of events on a computer system), but they are also just very practical when we want to find which file we edited or downloaded last Thursday when we don’t remember the name.</p>
<blockquote>
<p>Do <code>cd $env:homepath</code>. List all files recursively (recursively means include all files in all subdirectories) in your home directory where the filename matches the regular expression <code>'.*\.[tpl].*'</code>. Sort the output on the property LastWriteTime. Pipe to <code>Format-Table</code> and show only the properties Name, LastWriteTime and Length.</p>
</blockquote>
<h2 id="measure-object">Measure-Object</h2>
<p>You have already used <code>Measure-Command</code> to measure the time it takes to run a pipeline. If you want to count characters, words, lines and compute some statistics from these, then use <code>Measure-Object</code>.</p>
<div class="sourceCode" id="cb14"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb14-1"><a href="#cb14-1"></a><span class="fu">Get-ChildItem</span> -File C:\Windows\System32\ | <span class="fu">Measure-Object</span></span>
<span id="cb14-2"><a href="#cb14-2"></a><span class="fu">Get-ChildItem</span> -File C:\Windows\System32\ | <span class="fu">Measure-Object</span> -Property Length -Sum -Average</span></code></pre></div>
<h2 id="foreach-object-foreach">ForEach-Object, foreach, %</h2>
<p>You use <code>Where-Object</code> for filtering objects in the pipeline. You use <code>ForEach-Object</code> when you want to do something (with some flexibility) to each object in the pipeline. You can also use <a href="https://docs.microsoft.com/en-us/powershell/scripting/learn/ps101/06-flow-control">more standard loops and conditions</a>. You will typically use them if you create a script (which is just commands placed in a file).</p>
<div class="sourceCode" id="cb15"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb15-1"><a href="#cb15-1"></a><span class="kw">foreach</span> (<span class="va">$i</span> <span class="kw">in</span> 1..<span class="fu">4</span>) {notepad}</span>
<span id="cb15-2"><a href="#cb15-2"></a><span class="fu">Get-Process</span> notepad | <span class="fu">ForEach-Object</span> {<span class="fu">Write-Output</span> <span class="st">&quot;Terminating Notepad with id $($_.id)&quot;</span>;<span class="va">$_</span>.<span class="fu">Kill</span>()}</span></code></pre></div>
<p>Note: if you just wanted to stop all notepad-processes you could simply pipe to <code>Stop-Process</code>.</p>
<blockquote>
<p>Start a pipeline <code>'Set-Location', 'Get-Location', 'Push-Location' |</code> and use <code>ForEach-Object</code> so you can iterate over these three cmdlet-names and call <code>Get-Alias -Definition $_</code> for each of them</p>
</blockquote>
<h2 id="if-comparison-tests-branching">if, comparison, tests, “branching”</h2>
<p>Of course PowerShell also has <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_if">the if-statement</a>, a few examples:</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb16-1"><a href="#cb16-1"></a><span class="co"># if the Administrator-user account is enabled</span></span>
<span id="cb16-2"><a href="#cb16-2"></a><span class="kw">if</span> ( (Get-LocalUser -Name Administrator).<span class="fu">Enabled</span> )</span>
<span id="cb16-3"><a href="#cb16-3"></a>  { <span class="fu">Write-Output</span> <span class="st">&quot;It&#39;s enabled!&quot;</span> }</span>
<span id="cb16-4"><a href="#cb16-4"></a><span class="co"># if a a string is not empty</span></span>
<span id="cb16-5"><a href="#cb16-5"></a><span class="kw">if</span> ( <span class="va">$name</span>.<span class="fu">Length</span> -gt 0 ) { <span class="fu">Write-Output</span> <span class="st">&quot;Name has characters&quot;</span> }</span>
<span id="cb16-6"><a href="#cb16-6"></a><span class="co"># if a file exists</span></span>
<span id="cb16-7"><a href="#cb16-7"></a><span class="kw">if</span> ( <span class="fu">Test-Path</span> C:\Windows\System32\ntoskrnl.<span class="fu">exe</span> ) </span>
<span id="cb16-8"><a href="#cb16-8"></a>  { <span class="fu">Write-Output</span> <span class="st">&quot;OS exists!&quot;</span> }</span></code></pre></div>
<p>Note that sometimes it is easier to use <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.utility/compare-object">Compare-Object</a>, e.g. to copy only new or newer files</p>
<div class="sourceCode" id="cb17"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb17-1"><a href="#cb17-1"></a><span class="va">$src</span> = <span class="fu">Get-ChildItem</span> -Recurse <span class="st">&quot;C:\Users\Admin\test\&quot;</span></span>
<span id="cb17-2"><a href="#cb17-2"></a><span class="va">$dst</span> = <span class="fu">Get-ChildItem</span> -Recurse <span class="st">&quot;C:\Backup\&quot;</span></span>
<span id="cb17-3"><a href="#cb17-3"></a><span class="kw">if</span> (<span class="va">$src</span> -eq <span class="va">$NULL</span> -or <span class="va">$dst</span> -eq <span class="va">$null</span>) {</span>
<span id="cb17-4"><a href="#cb17-4"></a>  <span class="fu">Write-Output</span> <span class="st">&quot;Compare-Object does not like empty objects :)&quot;</span></span>
<span id="cb17-5"><a href="#cb17-5"></a>  <span class="kw">return</span></span>
<span id="cb17-6"><a href="#cb17-6"></a>}</span>
<span id="cb17-7"><a href="#cb17-7"></a><span class="fu">Compare-Object</span> -ReferenceObject <span class="va">$dst</span> -DifferenceObject <span class="va">$src</span> -Property LastWriteTime -PassThru |</span>
<span id="cb17-8"><a href="#cb17-8"></a> <span class="fu">Where-Object</span> {<span class="va">$_</span>.<span class="fu">SideIndicator</span> -eq &#39;=&gt;&#39;} |</span>
<span id="cb17-9"><a href="#cb17-9"></a> <span class="fu">Copy-Item</span> -Recurse -Force -Destination C:\Backup\</span></code></pre></div>
<p>When using <code>Compare-Object</code> with the <code>-PassThru</code> option the property <code>SideIndicator</code> is added to the object in the pipeline and can be used to select objects accro</p>
<h2 id="modules">Modules</h2>
<p>We can extend PowerShells functionality with modules. E.g. if we want to manage Windows Update through PowerShell, we can install a module for it</p>
<div class="sourceCode" id="cb18"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb18-1"><a href="#cb18-1"></a>Find-Module *windowsupdate*</span>
<span id="cb18-2"><a href="#cb18-2"></a><span class="co">#  Run as administrator </span></span>
<span id="cb18-3"><a href="#cb18-3"></a>Install-Module -Name PSWindowsUpdate</span>
<span id="cb18-4"><a href="#cb18-4"></a>Get-WindowsUpdate</span>
<span id="cb18-5"><a href="#cb18-5"></a>Get-WindowsUpdate -Download</span>
<span id="cb18-6"><a href="#cb18-6"></a><span class="co"># Get-WindowsUpdate -Install # maybe not now, since slow</span></span></code></pre></div>
<blockquote>
<p><code>Get-WindowsUpdate</code> by default contacts “Windows update server” which only covers updates for the operating system. Can you use <code>Get-WindowsUpdate</code> to contact “Microsoft Update server” (updates for other Microsoft software) instead?</p>
</blockquote>
<p>It is also nice to control fonts in PowerShell with the module WindowsConsoleFonts</p>
<div class="sourceCode" id="cb19"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb19-1"><a href="#cb19-1"></a>Install-Module -Name WindowsConsoleFonts -Force</span>
<span id="cb19-2"><a href="#cb19-2"></a><span class="fu">Get-Command</span> -Module WindowsConsoleFonts</span>
<span id="cb19-3"><a href="#cb19-3"></a>Set-ConsoleFont -Size 28 Consolas</span></code></pre></div>
<h2 id="scripts">Scripts</h2>
<p>A <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_scripts">PowerShell-script is just a collection of commands in a file</a>. To create a text file we can * use a text editor (vscode, nano, vim, notepad, …) * use <code>Out-File</code> (<code>&gt;</code>) with multiple additional <code>Out-File -Append</code> (<code>&gt;&gt;</code>) * use a <a href="https://en.wikipedia.org/w/index.php?title=Here_document&amp;oldid=985675265">here document</a> (called a <a href="https://powershell.org/2019/04/hear-hear-for-here-strings/">here string in PowerShell</a>)</p>
<p>For creating small files and showing exactly how we do it in this tutorial, the most practical is to use a here string, so let’s create the script <code>myscript.ps1</code> where we also demonstrate how we can give our script a parameter</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb20-1"><a href="#cb20-1"></a>@&#39;</span>
<span id="cb20-2"><a href="#cb20-2"></a><span class="kw">param</span>([<span class="dt">string</span>]<span class="va">$Name</span>)</span>
<span id="cb20-3"><a href="#cb20-3"></a><span class="st">&quot;Hello $Name, the size of this file is in Bytes:&quot;</span></span>
<span id="cb20-4"><a href="#cb20-4"></a>(<span class="fu">Get-ChildItem</span> .\myscript.<span class="fu">ps1</span>).<span class="fu">Length</span></span>
<span id="cb20-5"><a href="#cb20-5"></a>&#39;@ &gt; myscript.<span class="fu">ps1</span></span></code></pre></div>
<blockquote>
<p>Create the script above, execute it with/without providing the parameter <code>Name</code> and with/without providing av value for the parameter <code>Name</code></p>
</blockquote>
<p>Sometimes you will see <code>&amp;</code> as prefix to scripts or commands when you TAB-completion (try to rename <code>myscript.ps1</code> to <code>my script.ps1</code> and use TAB-completion to execute it). <code>&amp;</code> is the call-operator, browse <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_operators">about Operators</a> to learn more.</p>
<p>Whenever we code, we should use available tools to check for bad code quality. In PowerShell we can do this with <a href="https://github.com/PowerShell/PSScriptAnalyzer">PSScriptanalyzer</a> which is a static code analyzer for PowerShell. For bigger projects one should look into <a href="https://github.com/pester/Pester">Pester</a>.</p>
<div class="sourceCode" id="cb21"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb21-1"><a href="#cb21-1"></a>Install-Module -Name PSScriptAnalyzer</span>
<span id="cb21-2"><a href="#cb21-2"></a><span class="co"># use it on script myscript.ps1</span></span>
<span id="cb21-3"><a href="#cb21-3"></a>Invoke-ScriptAnalyzer myscript.<span class="fu">ps1</span></span>
<span id="cb21-4"><a href="#cb21-4"></a><span class="co"># no output is a good thing :)</span></span></code></pre></div>
<h1 id="powershell-2-domain-joined-hosts-and-remoting">PowerShell 2: Domain-joined hosts and Remoting</h1>
<p>We would like to manage remote hosts by connecting to them and executing commands without using a full Remote Desktop Protocol (RDP) GUI-session. RDP (port 3389) has been at the center of <a href="https://msrc.microsoft.com/update-guide/vulnerability/CVE-2019-0708">some vulnerabilities in recent years</a>, and automating management tasks is difficult with a GUI like RDP. With PowerShell remoting you can execute commands or login (create a session) on remote hosts <a href="https://docs.microsoft.com/en-us/powershell/scripting/learn/remoting/running-remote-commands">using either the WSMan or SSH protocols</a>. We will only focus on WSMan between Windows hosts. Let us examine how we can do remoting in a couple of different scenarios where the client is a Windows 10 (the host we are connecting from) and the server is Server 2019 (the host we are connecting to).</p>
<p>Note: We are now going to create a <em>Windows Domain</em>. This means that we have at least one domain controller where the Active Directory service is installed, and other client and server computers that have joined the domain by registering them in Active Directory. Users can then log in to computers that are joined to the domain with their user account in Active Directory (instead of a local user account) and we can manage groups of computers more easily. Active Directory is a core component in a Windows-based infrastructure and almost every company have an Active Directory installed. As you can imagine, Active Directory is a highly attractive target for attackers. A widely known incident (think also about how many unknown incidents there are) is the attack on <a href="https://doublepulsar.com/how-lockergoga-took-down-hydro-ransomware-used-in-targeted-attacks-aimed-at-big-business-c666551f5880">Norsk Hydro in 2019</a> which had an <a href="https://www.dn.no/bors/hydro/brasil/norsk-hydro/hackerangrepet-mot-hydro-enda-dyrere-enn-tidligere-antatt-ny-prislapp-pa-800-millioner-kroner/2-1-898620#:~:text=Prislappen%20p%C3%A5%20det%20det%20omfattende,hovedkontoret%20i%20Oslo%20etter%20angrepet.">estimated cost of roughly NOK 800 million</a></p>
<h3 id="prepare-environment">Prepare environment</h3>
<p>This lab assumes you have a Windows 10 host called <code>cl1</code>, and two Windows Server 2019 called <code>dc1</code> and <code>srv1</code>. You can create this environment by following the instructions <a href="https://gitlab.com/erikhje/dcsg1005/-/blob/master/heat-labs.md">Basic Infrastructure Orchestration</a> with the Heat template <a href="https://gitlab.com/erikhje/heat-mono/-/blob/master/cl_dc_srv_basic.yaml">cl_dc_srv_basic.yaml</a>. We install the services Active Directory and DNS on <code>dc1</code>, join <code>cl1</code> to the domain, while we leave <code>srv1</code> outside of the domain. We have chosen <code>sec.core</code> as our domain name. Before we create a domain, you need to set a password for the local Administrator user (who will become domain administrator) and you need to have a password for safe mode. For simplicity we let these be the same password (in production environments these should be unique of course). Choose a password before moving on (by “Choose a password” we mean either to use your password manager to generate a password for you or <a href="https://nettvett.no/passord/">create a password following best practice</a>). On <code>dc1</code> do (notice that since <code>Install-ADDSForest</code> have many parameters, we use <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_splatting">splatting</a>)</p>
<div class="sourceCode" id="cb22"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb22-1"><a href="#cb22-1"></a><span class="co"># run as administrator</span></span>
<span id="cb22-2"><a href="#cb22-2"></a>Install-WindowsFeature AD-Domain-Services, DNS -IncludeManagementTools</span>
<span id="cb22-3"><a href="#cb22-3"></a><span class="va">$Password</span> = <span class="fu">Read-Host</span> -Prompt &#39;Enter Password&#39; -AsSecureString</span>
<span id="cb22-4"><a href="#cb22-4"></a>Set-LocalUser -Password <span class="va">$Password</span> Administrator</span>
<span id="cb22-5"><a href="#cb22-5"></a><span class="va">$Params</span> = @{</span>
<span id="cb22-6"><a href="#cb22-6"></a>    DomainMode                    = &#39;WinThreshold&#39;</span>
<span id="cb22-7"><a href="#cb22-7"></a>    DomainName                    = &#39;sec.<span class="fu">core</span>&#39;</span>
<span id="cb22-8"><a href="#cb22-8"></a>    DomainNetbiosName             = &#39;SEC&#39;</span>
<span id="cb22-9"><a href="#cb22-9"></a>    ForestMode                    = &#39;WinThreshold&#39;</span>
<span id="cb22-10"><a href="#cb22-10"></a>    InstallDns                    = <span class="va">$true</span></span>
<span id="cb22-11"><a href="#cb22-11"></a>    NoRebootOnCompletion          = <span class="va">$true</span></span>
<span id="cb22-12"><a href="#cb22-12"></a>    SafeModeAdministratorPassword = <span class="va">$Password</span></span>
<span id="cb22-13"><a href="#cb22-13"></a>    Force                         = <span class="va">$true</span></span>
<span id="cb22-14"><a href="#cb22-14"></a>}</span>
<span id="cb22-15"><a href="#cb22-15"></a>Install-ADDSForest @Params</span>
<span id="cb22-16"><a href="#cb22-16"></a><span class="fu">Restart-Computer</span></span>
<span id="cb22-17"><a href="#cb22-17"></a><span class="co"># Log in as SEC\Administrator with password from above, test our domain</span></span>
<span id="cb22-18"><a href="#cb22-18"></a><span class="fu">Get-ADRootDSE</span></span>
<span id="cb22-19"><a href="#cb22-19"></a><span class="fu">Get-ADForest</span></span>
<span id="cb22-20"><a href="#cb22-20"></a><span class="fu">Get-ADDomain</span></span>
<span id="cb22-21"><a href="#cb22-21"></a><span class="co"># Any computers joined the domain?</span></span>
<span id="cb22-22"><a href="#cb22-22"></a><span class="fu">Get-ADComputer</span> -Filter *</span></code></pre></div>
<p>On <code>cl1</code> (who will join the domain) the following <em>needs to be done in Windows PowerShell</em> (NOT in PowerShell Core) since <code>Add-Computer</code> is not supported in PowerShell Core</p>
<div class="sourceCode" id="cb23"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb23-1"><a href="#cb23-1"></a><span class="co"># run as administrator</span></span>
<span id="cb23-2"><a href="#cb23-2"></a>Get-NetAdapter | Set-DnsClientServerAddress -ServerAddresses IP_ADDRESS_OF_DC1</span>
<span id="cb23-3"><a href="#cb23-3"></a><span class="va">$cred</span> = <span class="fu">Get-Credential</span> -UserName &#39;SEC\Administrator&#39; -Message &#39;Cred&#39;</span>
<span id="cb23-4"><a href="#cb23-4"></a><span class="fu">Add-Computer</span> -Credential <span class="va">$cred</span> -DomainName sec.<span class="fu">core</span> -PassThru -Verbose</span>
<span id="cb23-5"><a href="#cb23-5"></a><span class="fu">Restart-Computer</span></span></code></pre></div>
<p>Note: the following are just examples of typical scenarios and maybe not 100% accurate, see <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_remote_requirements">About Remote Requirements</a> for details.</p>
<h3 id="scenario-1-both-hosts-in-domain-logged-in-as-domain-administrator">Scenario 1: Both hosts in domain, logged in as Domain Administrator</h3>
<p>In this scenario, remoting works by default (but you do not want to be be logged in as domain administrator unless you really have to, think principle of least privilege)</p>
<div class="sourceCode" id="cb24"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb24-1"><a href="#cb24-1"></a><span class="fu">Enter-PSSession</span> dc1.<span class="fu">sec</span>.<span class="fu">core</span></span></code></pre></div>
<h3 id="scenario-2-both-hosts-in-domain-logged-in-as-local-user">Scenario 2: Both hosts in domain, logged in as local user</h3>
<p>In this scenario, you just have to supply supply credentials for a domain user (who needs to be in domain-administrators or builtin-administrators group) on the remote host</p>
<div class="sourceCode" id="cb25"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb25-1"><a href="#cb25-1"></a><span class="va">$cred</span> = <span class="fu">Get-Credential</span> -Username SEC\Admin -Message &#39;Cred&#39;</span>
<span id="cb25-2"><a href="#cb25-2"></a><span class="fu">Enter-PSSession</span> -Credential <span class="va">$cred</span> dc1.<span class="fu">sec</span>.<span class="fu">core</span></span></code></pre></div>
<h3 id="scenario-3-connect-to-host-outside-of-domain">Scenario 3: Connect to host outside of domain</h3>
<p>In this scenario, you have to register <code>srv1</code> as a trusted host for <code>cl1</code>, supply credentials for the user on the remote host, and set a local policy on the remote host.</p>
<p>First, on <code>srv1</code> do</p>
<div class="sourceCode" id="cb26"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb26-1"><a href="#cb26-1"></a><span class="fu">New-ItemProperty</span> -Name LocalAccountTokenFilterPolicy `</span>
<span id="cb26-2"><a href="#cb26-2"></a>  -Path HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System `</span>
<span id="cb26-3"><a href="#cb26-3"></a>  -PropertyType DWord -Value 1</span></code></pre></div>
<p>then, on <code>cl1</code>, you can do</p>
<div class="sourceCode" id="cb27"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb27-1"><a href="#cb27-1"></a><span class="co"># check if any trusted hosts already added so we dont overwrite</span></span>
<span id="cb27-2"><a href="#cb27-2"></a><span class="va">$curValue</span> = (<span class="fu">Get-Item</span> wsman:\localhost\Client\TrustedHosts).<span class="fu">value</span></span>
<span id="cb27-3"><a href="#cb27-3"></a><span class="kw">if</span> (<span class="va">$curValue</span> -eq &#39;&#39;) { </span>
<span id="cb27-4"><a href="#cb27-4"></a>  <span class="fu">Set-Item</span> wsman:\localhost\Client\TrustedHosts -Value <span class="st">&quot;IP_ADDRESS_OF_SRV1&quot;</span></span>
<span id="cb27-5"><a href="#cb27-5"></a>} <span class="kw">else</span> {</span>
<span id="cb27-6"><a href="#cb27-6"></a>  <span class="fu">Set-Item</span> wsman:\localhost\Client\TrustedHosts -Value <span class="st">&quot;$curValue, IP_ADDRESS_OF_SRV1&quot;</span></span>
<span id="cb27-7"><a href="#cb27-7"></a>}</span>
<span id="cb27-8"><a href="#cb27-8"></a><span class="va">$cred</span> = <span class="fu">Get-Credential</span> -Username Admin -Message &#39;Cred&#39;</span>
<span id="cb27-9"><a href="#cb27-9"></a><span class="fu">Enter-PSSession</span> -Credential <span class="va">$cred</span> IP_ADDRESS_OF_SRV1</span></code></pre></div>
<h3 id="learning-powershell-remoting-through-practice">Learning PowerShell Remoting through Practice</h3>
<blockquote>
<p>Log in to <code>cl1</code> as <code>CL1\Admin</code>, read and do all the examples in the article <a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_remote">About Remote</a>. After doing this, you should be comfortable with <code>Enter-PSSession</code>, <code>New-PSSession</code> and <code>Invoke-Command</code>.</p>
</blockquote>
<h3 id="copying-files-with-and-without-shares">Copying files with and without Shares</h3>
<p>In the Linux world you always copy files with <code>scp</code> and you can use this from Windows to a Linux host as well but the Windows-way of copying files between hosts is using existing shares (this only works for writing to domain controllers)</p>
<div class="sourceCode" id="cb28"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb28-1"><a href="#cb28-1"></a><span class="fu">Write-Output</span> heisan &gt; mysil.<span class="fu">txt</span></span>
<span id="cb28-2"><a href="#cb28-2"></a><span class="fu">Copy-Item</span> mysil.<span class="fu">txt</span> \\dc1\C$\users\admin</span>
<span id="cb28-3"><a href="#cb28-3"></a><span class="fu">Get-ChildItem</span> \users\admin</span>
<span id="cb28-4"><a href="#cb28-4"></a><span class="fu">Enter-PSSession</span> dc1</span>
<span id="cb28-5"><a href="#cb28-5"></a>Get-SmbShare</span>
<span id="cb28-6"><a href="#cb28-6"></a><span class="fu">Get-ChildItem</span> \users\admin</span></code></pre></div>
<p>or creating temporary shares (a share is a network file system, in Windows this is SMB (Server Message Block) sometimes called CIFS (Common Internet File System))</p>
<div class="sourceCode" id="cb29"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb29-1"><a href="#cb29-1"></a><span class="fu">Enter-PSSession</span> srv1</span>
<span id="cb29-2"><a href="#cb29-2"></a>New-SmbShare -Name <span class="st">&quot;admindocs$&quot;</span> -Path <span class="st">&quot;C:\users/admin/documents&quot;</span> -Temporary -FullAccess <span class="st">&quot;RESKIT\Administrator&quot;</span></span>
<span id="cb29-3"><a href="#cb29-3"></a><span class="kw">exit</span></span>
<span id="cb29-4"><a href="#cb29-4"></a><span class="fu">Copy-Item</span> mysil.<span class="fu">txt</span> \\srv1\admindocs$</span>
<span id="cb29-5"><a href="#cb29-5"></a><span class="fu">Enter-PSSession</span> srv1</span>
<span id="cb29-6"><a href="#cb29-6"></a><span class="fu">Get-ChildItem</span> C:\Users\Admin\Documents</span>
<span id="cb29-7"><a href="#cb29-7"></a>Remove-SmbShare admindocs$</span>
<span id="cb29-8"><a href="#cb29-8"></a><span class="kw">exit</span></span></code></pre></div>
<blockquote>
<p>Do the <code>New-SmbShare</code> cmdlet above, but put all the arguments in a hashtable (<a href="https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_splatting">splatting</a>)</p>
</blockquote>
<p>It is possible to do something similar to scp in PowerShell by establishing a remote session and then use <code>Copy-Item</code> with the <code>-ToSession</code> option</p>
<div class="sourceCode" id="cb30"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb30-1"><a href="#cb30-1"></a><span class="va">$sess</span> = <span class="fu">New-PSSession</span> srv1</span>
<span id="cb30-2"><a href="#cb30-2"></a><span class="fu">Copy-Item</span> .\mysil -ToSession <span class="va">$sess</span> C:\users\admin</span>
<span id="cb30-3"><a href="#cb30-3"></a><span class="fu">Get-PSSession</span></span>
<span id="cb30-4"><a href="#cb30-4"></a><span class="fu">Remove-PSSession</span> <span class="va">$sess</span></span>
<span id="cb30-5"><a href="#cb30-5"></a><span class="fu">Get-PSSession</span></span></code></pre></div>
<h1 id="additional-resources">Additional Resources</h1>
<p>What seems to be one of the best resources for learning PowerShell is the book <a href="https://www.manning.com/books/learn-windows-powershell-in-a-month-of-lunches-third-edition">Don Jones and Jeffery Hicks, Learn Windows PowerShell in a Month of Lunches</a> which also have a accompanying <a href="https://www.youtube.com/playlist?list=PL6D474E721138865A">video series</a>. A newer and more comprehensive video series is <a href="https://www.youtube.com/playlist?list=PLlVtbbG169nFq_hR7FcMYg32xsSAObuq8">PowerShell Master Class</a>. An excellent resource for PowerShell remoting is <a href="https://leanpub.com/secretsofpowershellremoting/read">Secrets of PowerShell Remoting</a>. A good introduction book is <a href="https://docs.microsoft.com/en-us/powershell/scripting/learn/ps101/00-introduction">PowerShell 101</a>.</p>
<h1 id="appendix-useful-sysadm-cmdlets-and-commands">Appendix: Useful SysAdm cmdlets and commands</h1>
<h2 id="system-info-cmdlets">System Info Cmdlets</h2>
<div class="sourceCode" id="cb31"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb31-1"><a href="#cb31-1"></a><span class="fu">Get-Process</span></span>
<span id="cb31-2"><a href="#cb31-2"></a><span class="fu">Get-Service</span></span>
<span id="cb31-3"><a href="#cb31-3"></a>Get-ComputerInfo | <span class="fu">Format-Table</span> -AutoSize -Property WindowsVersion,CsPartOfDomain</span>
<span id="cb31-4"><a href="#cb31-4"></a><span class="fu">Get-CimClass</span> Win32*</span>
<span id="cb31-5"><a href="#cb31-5"></a><span class="fu">Get-CimInstance</span> Win32_ComputerSystem</span></code></pre></div>
<h2 id="networking-cmdlets">Networking Cmdlets</h2>
<p>Useful networking cmdlets are</p>
<div class="sourceCode" id="cb32"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb32-1"><a href="#cb32-1"></a>Test-NetConnection</span>
<span id="cb32-2"><a href="#cb32-2"></a>Get-NetAdapter</span>
<span id="cb32-3"><a href="#cb32-3"></a>Get-NetConnectionProfile</span>
<span id="cb32-4"><a href="#cb32-4"></a>Get-NetIPConfiguration</span>
<span id="cb32-5"><a href="#cb32-5"></a>Get-NetTCPConnection</span>
<span id="cb32-6"><a href="#cb32-6"></a>Get-NetRoute</span>
<span id="cb32-7"><a href="#cb32-7"></a>Resolve-DnsName</span>
<span id="cb32-8"><a href="#cb32-8"></a>Get-DnsClient</span>
<span id="cb32-9"><a href="#cb32-9"></a>Get-DnsClientServerAddress</span>
<span id="cb32-10"><a href="#cb32-10"></a>Get-DnsClientGlobalSetting</span>
<span id="cb32-11"><a href="#cb32-11"></a>Clear-DnsClientCache</span></code></pre></div>
<p>These also have corresponding “Set-” cmdlets, and some useful pipelines are</p>
<div class="sourceCode" id="cb33"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb33-1"><a href="#cb33-1"></a>Set-DnsClientGlobalSetting -SuffixSearchList @(<span class="st">&quot;node.consul&quot;</span>)</span>
<span id="cb33-2"><a href="#cb33-2"></a>Get-NetAdapter | Set-DnsClient -ConnectionSpecificSuffix <span class="st">&quot;node.consul&quot;</span></span>
<span id="cb33-3"><a href="#cb33-3"></a>Get-NetAdapter | Set-DnsClientServerAddress -ServerAddresses IP_ADDRESS_OF_DNS_SERVER</span>
<span id="cb33-4"><a href="#cb33-4"></a>Get-NetAdapter | Get-NetIPInterface -Addressfamily IPv4 | Set-NetIPInterface -DHCP Enabled</span></code></pre></div>
<h2 id="troubleshooting-remoting">Troubleshooting remoting</h2>
<p>If remoting does not work, or if you are trying to set up remoting on hosts that are not part of the same domain (or not joined to any domain), here are som useful commands</p>
<div class="sourceCode" id="cb34"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb34-1"><a href="#cb34-1"></a><span class="fu">Get-Help</span> about_remote_requirements -Online</span>
<span id="cb34-2"><a href="#cb34-2"></a><span class="fu">Get-Service</span> WinRM                          <span class="co"># Is the service running?</span></span>
<span id="cb34-3"><a href="#cb34-3"></a>Get-NetTCPConnection -LocalPort 5985,5986  <span class="co"># Listening service on the right ports?</span></span>
<span id="cb34-4"><a href="#cb34-4"></a>Test-NetConnection -Port 5985 IP_ADDRESS_OF_DC1</span>
<span id="cb34-5"><a href="#cb34-5"></a><span class="fu">Test-WSMan</span></span>
<span id="cb34-6"><a href="#cb34-6"></a><span class="fu">Test-WSMan</span> -ComputerName srv2 -Authentication Default</span>
<span id="cb34-7"><a href="#cb34-7"></a><span class="fu">Get-Item</span> WSMan:\localhost\Client\TrustedHosts <span class="co"># Any trusted hosts?</span></span>
<span id="cb34-8"><a href="#cb34-8"></a><span class="co"># if Enable-PSRemoting -Force does not work try</span></span>
<span id="cb34-9"><a href="#cb34-9"></a>winrm quickconfig</span></code></pre></div>
<h2 id="security-notes">Security notes</h2>
<p>When studying kerberoasting, see <a href="https://techcommunity.microsoft.com/t5/core-infrastructure-and-security/decrypting-the-selection-of-supported-kerberos-encryption-types/ba-p/1628797">Decrypting the Selection of Supported Kerberos Encryption Types</a>.</p>
<div class="sourceCode" id="cb35"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb35-1"><a href="#cb35-1"></a><span class="fu">Get-ADComputer</span> -Properties msDS-SupportedEncryptionTypes -filter *</span></code></pre></div>
<h2 id="mounting-and-unmounting-disks">Mounting and Unmounting disks</h2>
<p>If you attach a disk/volume/storage of some kind, you can do the following once to make it usable as a drive</p>
<div class="sourceCode" id="cb36"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb36-1"><a href="#cb36-1"></a><span class="co"># Find disk number:</span></span>
<span id="cb36-2"><a href="#cb36-2"></a>Get-Disk</span>
<span id="cb36-3"><a href="#cb36-3"></a><span class="co"># Initialize</span></span>
<span id="cb36-4"><a href="#cb36-4"></a>Initialize-Disk DISK_NUMBER</span>
<span id="cb36-5"><a href="#cb36-5"></a><span class="co"># Partition and format:</span></span>
<span id="cb36-6"><a href="#cb36-6"></a>New-Partition -DiskNumber DISK_NUMBER -UseMaximumSize -AssignDriveLetter | Format-Volume</span>
<span id="cb36-7"><a href="#cb36-7"></a><span class="fu">Get-PSDrive</span></span></code></pre></div>
<p>After this you can remove it and reattach repeatedly like this (if Disk number 1, partition number 2 and mounted as drive letter <code>D:</code>):</p>
<div class="sourceCode" id="cb37"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb37-1"><a href="#cb37-1"></a><span class="co"># &quot;Unmount&quot;</span></span>
<span id="cb37-2"><a href="#cb37-2"></a>Get-Volume -Drive D | Get-Partition | Remove-PartitionAccessPath -AccessPath D:\</span>
<span id="cb37-3"><a href="#cb37-3"></a><span class="co"># &quot;Mount&quot;</span></span>
<span id="cb37-4"><a href="#cb37-4"></a>Get-Disk -Number 1 | Get-Partition -PartitionNumber 2 | Add-PartitionAccessPath -AccessPath &#39;D:\&#39;</span></code></pre></div>
<h2 id="scheduled-tasks">Scheduled Tasks</h2>
<p>Adam Betram (“Adam the automator”) has many useful blog posts on PowerShell, I recommend <a href="https://adamtheautomator.com/powershell-scheduled-task/">How to Set Up and Manage Scheduled Tasks with PowerShell</a></p>
<h1 id="appendix-other-useful-aspects">Appendix: Other Useful Aspects</h1>
<h2 id="variable-array-and-hashtable">Variable, Array and Hashtable</h2>
<p>A variable can represent any kind of object, and a variable can be grouped into an array or a hashtable. In an array, each element has a numeric index. In a hashtable each element has a key as index (in other words, a hashtable is a collection of key-value pairs).</p>
<div class="sourceCode" id="cb38"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb38-1"><a href="#cb38-1"></a><span class="va">$a</span> = &#39;hei&#39;</span>
<span id="cb38-2"><a href="#cb38-2"></a><span class="va">$a</span>.<span class="fu">gettype</span>()</span>
<span id="cb38-3"><a href="#cb38-3"></a><span class="va">$a</span> = <span class="fu">Get-ChildItem</span> C:\Windows\system.<span class="fu">ini</span></span>
<span id="cb38-4"><a href="#cb38-4"></a><span class="va">$a</span>.<span class="fu">gettype</span>()</span>
<span id="cb38-5"><a href="#cb38-5"></a><span class="va">$a</span> = @(&#39;frodeh&#39;,&#39;kelly&#39;)</span>
<span id="cb38-6"><a href="#cb38-6"></a><span class="va">$a</span>.<span class="fu">gettype</span>()</span>
<span id="cb38-7"><a href="#cb38-7"></a><span class="va">$a</span>[1]</span>
<span id="cb38-8"><a href="#cb38-8"></a><span class="va">$a</span></span>
<span id="cb38-9"><a href="#cb38-9"></a><span class="va">$a</span> = @{&#39;frodeh&#39;=&#39;Frode Haug&#39;;&#39;kelly&#39;=&#39;Jia-Chun Lin&#39;}</span>
<span id="cb38-10"><a href="#cb38-10"></a><span class="va">$a</span>.<span class="fu">gettype</span>()</span>
<span id="cb38-11"><a href="#cb38-11"></a><span class="va">$a</span>[1]</span>
<span id="cb38-12"><a href="#cb38-12"></a><span class="va">$a</span>[&#39;kelly&#39;]</span>
<span id="cb38-13"><a href="#cb38-13"></a><span class="va">$a</span></span>
<span id="cb38-14"><a href="#cb38-14"></a><span class="va">$a</span>.<span class="fu">length</span></span>
<span id="cb38-15"><a href="#cb38-15"></a><span class="va">$a</span>.<span class="fu">keys</span></span></code></pre></div>
<p>Useful Hashtable</p>
<div class="sourceCode" id="cb39"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb39-1"><a href="#cb39-1"></a><span class="fu">Get-ChildItem</span> C:\Windows\System32\ntoskrnl.<span class="fu">exe</span> | <span class="fu">Select-Object</span> -Property Name,@{name=&#39;ReadableSize&#39;;expression={<span class="va">$_</span>.<span class="fu">Length</span>/1MB}}</span></code></pre></div>
<blockquote>
<p>Using the hashtable <code>$a</code> above (the last example), write a command line which will output “User frodeh has real name Frode Haug”</p>
</blockquote>
<h2 id="accessing-.net">Accessing .NET</h2>
<p>Sometimes you will not find a cmdlet that does exactly what you need to do. In those situations it is useful to know that through PowerShell you have access to everything in .NET (PowerShell is built on top of .NET). E.g. in the textbook Thomas Lee in one recipe writes <em>PowerShell’s certificate provider does not support copying a certificate into the root CA store. You can overcome this limitation by dipping down into the .NET framework as shown in step 7</em></p>
<p>You can access .NET-objects by starting a command with a bracket</p>
<div class="sourceCode" id="cb40"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb40-1"><a href="#cb40-1"></a>[math]::PI</span>
<span id="cb40-2"><a href="#cb40-2"></a>2.<span class="fu">3</span>*4.<span class="fu">5</span></span>
<span id="cb40-3"><a href="#cb40-3"></a>[math]::Round(2.<span class="fu">3</span>*4.<span class="fu">5</span>)</span>
<span id="cb40-4"><a href="#cb40-4"></a><span class="fu">Get-Date</span></span>
<span id="cb40-5"><a href="#cb40-5"></a>[datetime]::Now</span>
<span id="cb40-6"><a href="#cb40-6"></a>[datetime]::UtcNow</span></code></pre></div>
<blockquote>
<p>Try <code>[System</code> and TAB your way through possible .NET-objects.</p>
</blockquote>
<p>In PowerShell you use the <code>.</code>-operator when you access the properties and methods of an object, e.g. <code>(Get-Process powershell).WorkingSet</code>. The <code>::</code>-operator is used to access static properties and methods (properties and methods that does not belong to a specific instance of a class), you can view these with <code>Get-Member</code> as well</p>
<div class="sourceCode" id="cb41"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb41-1"><a href="#cb41-1"></a>(<span class="fu">Get-Date</span>).<span class="fu">GetType</span>()</span>
<span id="cb41-2"><a href="#cb41-2"></a><span class="fu">Get-Date</span> | <span class="fu">Get-Member</span></span>
<span id="cb41-3"><a href="#cb41-3"></a><span class="fu">Get-Date</span> | <span class="fu">Get-Member</span> -Static</span>
<span id="cb41-4"><a href="#cb41-4"></a>[datetime] | <span class="fu">Get-Member</span></span>
<span id="cb41-5"><a href="#cb41-5"></a>[datetime] | <span class="fu">Get-Member</span> -Static</span></code></pre></div>
<h2 id="generating-passwords">Generating Passwords</h2>
<p>Never generate a password yourself unless you know you really need to type it manually several times (but if you really need to do that, create <a href="https://docs.microsoft.com/en-us/microsoft-365/admin/misc/password-policy-recommendations">a long hard-to-brute-force-guess-password</a>, also consider reading <a href="https://www.explainxkcd.com/wiki/index.php?title=936:_Password_Strength&amp;oldid=201051">936: Password Strength</a>). Always let a good local random password generator create passwords for services, databases, accounts, cryptography, etc. This is easy to do in a script (do not ask for passwords with <code>Read-Host</code> unless absolutely necessary). In Windows PowerShell (5.1) you can do</p>
<div class="sourceCode" id="cb42"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb42-1"><a href="#cb42-1"></a><span class="fu">Add-Type</span> -AssemblyName &#39;System.<span class="fu">Web</span>&#39;</span>
<span id="cb42-2"><a href="#cb42-2"></a>[System.<span class="fu">Web</span>.<span class="fu">Security</span>.<span class="fu">Membership</span>]::GeneratePassword(20,0)</span></code></pre></div>
<p>In PowerShell core this is not possible (since PowerShell core is based on .NET core which has less functionality than the full .NET). You have to do something like (note: <code>Get-Random</code> <a href="https://www.sans.org/blog/truerng-random-numbers-with-powershell-and-math-net-numerics">is a good random number generator in PowerShell since at least PowerShell 5.0</a>)</p>
<div class="sourceCode" id="cb43"><pre class="sourceCode powershell"><code class="sourceCode powershell"><span id="cb43-1"><a href="#cb43-1"></a>-join `</span>
<span id="cb43-2"><a href="#cb43-2"></a>(&#39;abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPRSTUVWXYZ0123456789 !<span class="st">&quot;#$%&amp;()*+,-./:;&lt;=&gt;?@[\]^_`{|}~&#39;.ToCharArray() | </span></span>
<span id="cb43-3"><a href="#cb43-3"></a> <span class="fu">Get-Random</span> -Count 20)</span>
<span id="cb43-4"><a href="#cb43-4"></a></span>
<span id="cb43-5"><a href="#cb43-5"></a><span class="co"># or third party</span></span>
<span id="cb43-6"><a href="#cb43-6"></a>Install-Module MlkPwgen</span>
<span id="cb43-7"><a href="#cb43-7"></a>New-Password -Length 20</span></code></pre></div>
